package mmm.utils;


import java.util.HashMap;
import java.util.HashSet;
import java.util.Map;

import net.minecraft.block.Block;
import net.minecraft.client.renderer.block.model.ModelResourceLocation;
import net.minecraft.item.Item;
import net.minecraft.item.ItemBlock;
import net.minecraftforge.client.model.ModelLoader;
import net.minecraftforge.fml.common.registry.GameRegistry;



public class URegistration
{

	private static final HashMap< Item , Boolean > ITEMS = new HashMap< Item , Boolean >( );
	private static final HashSet< Block > BLOCKS = new HashSet< Block >( );


	public static void addItem( final Item item )
	{
		URegistration.addItem( item , true );
	}


	public static void addItem( final Item item , final boolean registerModel )
	{
		GameRegistry.register( item );
		URegistration.ITEMS.put( item , registerModel );
	}


	public static void addBlock( final Block block )
	{
		URegistration.addBlock( block , true );
	}


	public static void addBlock( final Block block , final Item blockItem )
	{
		URegistration.addBlock( block , blockItem , true );
	}


	public static void addBlock( final Block block , final boolean registerItemModel )
	{
		URegistration.addBlock( block , new ItemBlock( block ).setRegistryName( block.getRegistryName( ) ) ,
				registerItemModel );
	}


	public static void addBlock( final Block block , final Item blockItem , final boolean registerItemModel )
	{
		GameRegistry.register( block );
		URegistration.BLOCKS.add( block );
		if ( blockItem != null ) {
			URegistration.addItem( blockItem , registerItemModel );
		}
	}


	public static void registerRecipes( )
	{
		for ( final Block block : URegistration.BLOCKS ) {
			if ( block instanceof I_URecipeRegistrar ) {
				( (I_URecipeRegistrar) block ).registerRecipe( );
			}
		}

		for ( final Item item : URegistration.ITEMS.keySet( ) ) {
			if ( item instanceof I_URecipeRegistrar ) {
				( (I_URecipeRegistrar) item ).registerRecipe( );
			}
		}
	}


	public static void setupItemModels( )
	{
		for ( final Map.Entry< Item , Boolean > entry : URegistration.ITEMS.entrySet( ) ) {
			if ( !entry.getValue( ) ) {
				continue;
			}
			final Item item = entry.getKey( );
			ModelLoader.setCustomModelResourceLocation( item , 0 ,
					new ModelResourceLocation( item.getRegistryName( ) , "inventory" ) );
		}
	}
}
